#ifndef _WEB_RADIO_COMMON_H_
#define _WEB_RADIO_COMMON_H_

#include <stdio.h>// fprintf

#define VERSION "v0.1"
#define APP_NAME "Web Radio Player "VERSION

/* Select system */
//#undef LINUX
#define LINUX
#undef WIN32
//#define WIN32

/* You want a truckload of debugging output? */
//#define DEBUG
//#define DDEBUG

#define xDPRINT(fmt, args...)
#define xWEB_MSG(fmt, args...)

#ifdef LINUX
# define strnicmp strncasecmp
#ifdef DEBUG
# define DPRINT(fmt, args...) fprintf(stderr, fmt, ## args)
#else
# define DPRINT(fmt, args...)
#endif

#ifdef DDEBUG
# define DDPRINT(fmt, args...) fprintf(stderr, fmt, ## args)
#else
# define DDPRINT(fmt, args...)
#endif

#define WEB_MSG(fmt, args...) fprintf(stderr, fmt, ## args)

#else
#ifdef WIN32// FIXME Windows print functions

#ifdef DEBUG
# define DPRINT(fmt, args...) fprintf(stderr, fm, ## __VA_ARGS__)
#else
# define DPRINT(fmt, args...)
#endif

#ifdef DDEBUG
# define DDPRINT(fmt, args...) fprintf(stderr, fm, ## __VA_ARGS__)
#else
# define DDPRINT(fmt, args...)
#endif

#define WEB_MSG(fmt, args...) fprintf(stderr, fmt, ## __VA_ARGS__)

#define snprintf _snprintf

#endif// #ifdef WIN32
#endif// #ifdef LINUX

// Max characters
#define MAX_USER_NAME        31// 31 chars
#define MAX_PASSWORD_LENGTH  31// 31 chars
#define MAX_HOST_NAME       255// 255 chars
#define MAX_FILE_NAME        63// 63 chars

#define MAX_RESPONSE_LINE_LENGTH 1024
/** Protocol type: http, rtsp, mms, ... */
const char* web_protocol;
/** User name to connect to servers */
//char web_user_name[MAX_USER_NAME + 1];
/** Password to connect to servers */
//char web_password[MAX_PASSWORD_LENGTH + 1];
/** The server name or server ip */
char web_host[MAX_HOST_NAME + 1];
/** The server port */
int web_port;
/** URL file name */
char web_file[MAX_FILE_NAME + 1];

const char* web_proxy;
int web_proxy_port;

/** Buffer size to receive text metadata, max chars. */
#define MAX_METADATA_LENGTH (16 * 255)
char web_metadata_buf[MAX_METADATA_LENGTH + 1];

/* volatile */int web_quit_request;

#endif// _WEB_RADIO_COMMON_H_
